#include<stdio.h>
#include<stdlib.h>

#include<gsl/gsl_matrix.h>
#include<gsl/gsl_blas.h>

#define RANDOM (double)(drand48())

//definition of Fortran routine
void dsyrk_(char *uplo, char *trans, int *L, int *K, double *alpha, double *A, int *lda, double *beta, double *C, int *ldc);

static void printm(char *str, double *A, int n, int m);

int main(void)
{
  int i,j;
  //matrix dim.
  int N=3;
  int M=2;

  double alpha=-1.0;
  double beta=1.0;

  gsl_matrix *A, *B, *C;

  A = gsl_matrix_alloc(N,N);
  B = gsl_matrix_alloc(N,N);
  C = gsl_matrix_alloc(N,M);

  //make up random matrices
  A->data[0]=1.66;
  A->data[1]=1.42;
  A->data[2]=1.09;
  A->data[3]=1.42;
  A->data[4]=1.80;
  A->data[5]=1.05;
  A->data[6]=1.09;
  A->data[7]=1.05;
  A->data[8]=0.84;

  C->data[0]=1.66;
  C->data[1]=1.42;
  C->data[2]=1.42;
  C->data[3]=1.8;
  C->data[4]=1.09;
  C->data[5]=1.05;

  printm("A before", A->data, N, N);
  //printm("C before", C->data, N, M);

  //'uncomment' the following functions to compare results

  //dgemm gives correct result
  //gsl_blas_dgemm(CblasNoTrans, CblasTrans, alpha, C, C, beta, A);

  //dsyrk gives wrong result
  //gsl_blas_dsyrk(CblasLower, CblasNoTrans, alpha, C, beta, A);

  //fortran dsyrk is correct, matrix must be transposed and 'upper' 
  //parameter selected for a lower triangular matrix operation
  dsyrk_("U", "T", &N, &M, &alpha, C->data, &M, &beta, A->data, &N);

  printm("A after", A->data, N, N);
      

  return 0;
}

void printm(char *str, double *A, int n, int m) {
  int i, j;
  printf ("\n%s\n", str);
  for (i = 0; i < n; i++) {
    for (j = 0; j < m; j++) {
      printf ("%.8g\t", A[i*m + j]);
    }
    printf ("\n");
  }
}

